// $Id: CExcepciones.hpp,v 1.10 2001/09/25 14:26:27 jpl Exp $

#if !defined( _CExcepciones_HPP_ )
#define _CExcepciones_HPP_

#include <string>

// Cadenas de error.
// Genrico.
const string ERROR_COMPILACION     = "Error en la compilacin. ";
// Semntico.
const string NO_HAY_MAIN            = "No existe main().";
const string PALABRA_RESERVADA      = "Palabra reservada.";
const string REDEFINICION           = "Redefinicin no permitida.";
const string NO_ES_UNA_CLASE        = "No es una clase.";
const string NO_ES_UNA_VARIABLE     = "No es una variable.";
const string VARIABLE_NO_DECLARADA  = "Variable no declarada.";
const string METODO_NO_DECLARADO    = "Mtodo no declarado.";
const string MIEMBRO_NO_DECLARADO   = "Miembro no declarado.";
const string METODO_PRIVADO         = "Es mtodo privado.";
const string ATRIBUTO_PRIVADO       = "Es atributo privado.";
const string MIEMBRO_PRIVADO        = "Es miembro privado.";
const string FUNCION_NO_VISIBLE     = "Funcin no visible.";
const string PARAMETROS_INCORRECTOS = "Parmetros incorrectos.";
const string VIOLACION_DE_TIPOS     = "Violacin de tipos.";
const string NO_A_CONSTANTE         = "No se asigna a constantes.";
const string SOLO_UN_MAIN           = "Slo puede haber un main()";
const string NO_SOBRECARGA          = "No se permite la sobrecarga.";

//
// PALABRARESERVADAEX
//
class Palabra_Reservada_Ex {
private:
  string message;
public:
  Palabra_Reservada_Ex()
    : message("Excepcin: Palabra reservada."){}
  string what() const { return message; }
};

//
// ARGUMENTOS_INCORRECTOS
//
class Argumentos_Incorrectos_Ex {
private:
  string message;
public:
  Argumentos_Incorrectos_Ex()
    : message("Excepcin: Argumentos incorrectos."){}
  Argumentos_Incorrectos_Ex(string m)
    : message("Excepcin: Argumentos incorrectos." + m){}
  string what() const { return message; }
};

//
// SOLO_AYUDA
//
class Solo_Ayuda_Ex {
private:
  string message;
public:
  Solo_Ayuda_Ex()
    : message("Excepcin: Slo ayuda."){}
  string what() const { return message; }
};

//
// LEXICO_ERROR
//
class Lexico_Error_Ex {
  string message;
public:
  Lexico_Error_Ex()
    : message("Lxico."){}
  Lexico_Error_Ex(string m)
    : message("Lxico: " + m){}
  string what() const { return message; }
};

//
// SINTACTICO_ERROR
//
class Sintactico_Error_Ex {
  string message;  
public:
  Sintactico_Error_Ex()
    : message("Sintctico."){}
  Sintactico_Error_Ex(string m)
    : message("Sintctico: " + m){}
  string what() const { return message; }
};

//
// SEMANTICO_ERROR
//
class Semantico_Error_Ex {
  string message;
  string error;
public:
  Semantico_Error_Ex()
    : message("Semntico."){ error = ""; }
  Semantico_Error_Ex(string m)
    : message("Semntico: " + m){ error = m; }
  string what() const { return message; }
  string Error() const { return error; }
};

//
// HUBO_ERROR_EX
//
class Hubo_Error_Ex {
  string message;
public:
  Hubo_Error_Ex()
    : message("Error en la compilacin."){}
  Hubo_Error_Ex(string m)
    : message("Error en la compilacin: " + m){}
  string what() const { return message; }
};

#endif // _CExcepciones_HPP_
