// $Id: CProduccion.cpp,v 1.27 2001/09/25 18:53:34 jpl Exp $

#include "CProduccion.hpp"

//
// CPRODUCCION
//
CProduccion::CProduccion(void)
{
  lugar = "";
  codigo.clear();
  pcodigo.clear();
  tprod = "";
  lobjetos.clear();
}

//
// SET
//
void
CProduccion::Set(const string& a, const vector<string>& c)
{
  antecedente = a;
  consecuente = c;
}

void 
CProduccion::Set_Lugar ( string l)
{
  lugar = l;
}

void
CProduccion::Set_Codigo (vector<string> c)
{
  codigo = c;
}

void 
CProduccion::Add_Codigo (string c)
{
  codigo.push_back(c);
}

void
CProduccion::Set_PCodigo (vector<string> c)
{
  pcodigo = c;
}

void 
CProduccion::Add_PCodigo (string c)
{
  pcodigo.push_back(c);
}
void
CProduccion::Set_TProd (string c)
{
  tprod = c;
}
void
CProduccion::Set_LObjetos (vector<string> c)
{
  lobjetos = c;
}
void 
CProduccion::Add_Objeto (string c)
{
  lobjetos.push_back(c);
}

//
// INICIALIZAR_PRODUCCIONES
//
void
Inicializar_Gramatica(Gramatica& p)
{
  vector<string> consecuente_aux;
  CProduccion prod_aux;

  // 1. compilation_unit
  consecuente_aux.push_back(S_1_1);
  consecuente_aux.push_back(NT_LISTA_TYPE_DECLARATION);
  consecuente_aux.push_back(S_1_0);
  consecuente_aux.push_back(G_1_0);
  prod_aux.Set(NT_COMPILATION_UNIT, consecuente_aux);
  p.push_back(prod_aux);
  
  // 2. lista_type_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_TYPE_DECLARATION);
  consecuente_aux.push_back(NT_LISTA_TYPE_DECLARATION);
  consecuente_aux.push_back(S_2_0);
  consecuente_aux.push_back(G_2_0);
  prod_aux.Set(NT_LISTA_TYPE_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);

  // 3. lista_type_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(S_3_0);
  consecuente_aux.push_back(G_3_0);
  prod_aux.Set(NT_LISTA_TYPE_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);

  // 4. type_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_CLASS_DECLARATION);
  consecuente_aux.push_back(S_4_0);
  consecuente_aux.push_back(G_4_0);
  prod_aux.Set(NT_TYPE_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);
  
  // 5. class_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_MODIFIER);
  consecuente_aux.push_back(T_CLASS);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_5_2);
  consecuente_aux.push_back(T_LLAVES_ABRIR);
  consecuente_aux.push_back(S_5_1);  
  consecuente_aux.push_back(NT_LISTA_FIELD_DECLARATION);
  consecuente_aux.push_back(T_LLAVES_CERRAR);
  consecuente_aux.push_back(S_5_0);
  consecuente_aux.push_back(G_5_0);
  prod_aux.Set(NT_CLASS_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);
  
  // 6. lista_field_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(S_6_2);
  consecuente_aux.push_back(NT_FIELD_DECLARATION);
  consecuente_aux.push_back(S_6_1);
  consecuente_aux.push_back(NT_LISTA_FIELD_DECLARATION);
  consecuente_aux.push_back(S_6_0); 
  consecuente_aux.push_back(G_6_0); 
  prod_aux.Set(NT_LISTA_FIELD_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);
  
  // 7. lista_field_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(S_7_0); 
  consecuente_aux.push_back(G_7_0); 
  prod_aux.Set(NT_LISTA_FIELD_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);

  // 8. modifier
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PUBLIC);
  consecuente_aux.push_back(S_8_0);
  consecuente_aux.push_back(G_8_0);
  prod_aux.Set(NT_MODIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 9. modifier
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PRIVATE);
  consecuente_aux.push_back(S_9_0);
  consecuente_aux.push_back(G_9_0);
  prod_aux.Set(NT_MODIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 10. modifier
  consecuente_aux.clear();
  consecuente_aux.push_back(S_10_0);
  consecuente_aux.push_back(G_10_0);
  prod_aux.Set(NT_MODIFIER, consecuente_aux);
  p.push_back(prod_aux);  

  // 11. identifier
  // No tengo estoy muy claro, pero pienso que de esta produccin ya
  // se ha encargado el lxico, luego no introduce nada, o ms bien,
  // deja que sea el lxico el que lo introduzca.
  consecuente_aux.clear();
  consecuente_aux.push_back(S_11_0); 
  consecuente_aux.push_back(G_11_0); 
  prod_aux.Set(NT_IDENTIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 12. field_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_MODIFIER);
  consecuente_aux.push_back(NT_TYPE);
  consecuente_aux.push_back(S_12_1);
  consecuente_aux.push_back(NT_FIELD_DECLARATION_PRIMA);
  consecuente_aux.push_back(S_12_0); 
  consecuente_aux.push_back(G_12_0); 
  prod_aux.Set(NT_FIELD_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);
 
  // 13. field_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_13_0); 
  consecuente_aux.push_back(G_13_0); 
  prod_aux.Set(NT_FIELD_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);

  // 14. field_declaration_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_14_1);
  consecuente_aux.push_back(NT_CONSTRUCTOR_DECLARATION);
  consecuente_aux.push_back(S_14_0);
  consecuente_aux.push_back(G_14_0);
  prod_aux.Set(NT_FIELD_DECLARATION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 15. field_declaration_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_15_1);
  consecuente_aux.push_back(NT_FIELD_DECLARATION_PRIMA_PRIMA);
  consecuente_aux.push_back(S_15_0); 
  consecuente_aux.push_back(G_15_0); 
  prod_aux.Set(NT_FIELD_DECLARATION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 16. field_declaration_prima_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_16_1);
  consecuente_aux.push_back(NT_VARIABLE_DECLARATION);
  consecuente_aux.push_back(S_16_0); 
  consecuente_aux.push_back(G_16_0); 
  prod_aux.Set(NT_FIELD_DECLARATION_PRIMA_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 17. field_declaration_prima_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_17_1);
  consecuente_aux.push_back(NT_METHOD_DECLARATION);
  consecuente_aux.push_back(S_17_0); 
  consecuente_aux.push_back(G_17_0); 
  prod_aux.Set(NT_FIELD_DECLARATION_PRIMA_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 18. method_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PARENTESIS_ABRIR);
  consecuente_aux.push_back(S_18_2);
  consecuente_aux.push_back(NT_OPCIONAL_PARAMETER_LIST);
  consecuente_aux.push_back(T_PARENTESIS_CERRAR);
  consecuente_aux.push_back(NT_LISTA_CORCHETES);
  consecuente_aux.push_back(S_18_1);
  consecuente_aux.push_back(NT_METHOD_DECLARATION_FINAL);
  consecuente_aux.push_back(S_18_0); 
  consecuente_aux.push_back(G_18_0); 
  prod_aux.Set(NT_METHOD_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);

  // 19. opcional_parameter_list
  consecuente_aux.clear();
  consecuente_aux.push_back(S_19_1);
  consecuente_aux.push_back(NT_PARAMETER_LIST);
  consecuente_aux.push_back(S_19_0); 
  consecuente_aux.push_back(G_19_0); 
  prod_aux.Set(NT_OPCIONAL_PARAMETER_LIST, consecuente_aux);
  p.push_back(prod_aux);

  // 20. opcional_parameter list
  consecuente_aux.clear();
  consecuente_aux.push_back(S_20_0); 
  consecuente_aux.push_back(G_20_0); 
  prod_aux.Set(NT_OPCIONAL_PARAMETER_LIST, consecuente_aux);
  p.push_back(prod_aux);

  // 21. lista_corchetes.
  consecuente_aux.clear();
  consecuente_aux.push_back(T_CORCHETES_ABRIR);
  consecuente_aux.push_back(T_CORCHETES_CERRAR);
  consecuente_aux.push_back(NT_LISTA_CORCHETES);
  consecuente_aux.push_back(S_21_0);
  consecuente_aux.push_back(G_21_0); 
  prod_aux.Set(NT_LISTA_CORCHETES, consecuente_aux);
  p.push_back(prod_aux);

  // 22. lista_corchetes.
  consecuente_aux.clear();
  consecuente_aux.push_back(S_22_0); 
  consecuente_aux.push_back(G_22_0); 
  prod_aux.Set(NT_LISTA_CORCHETES, consecuente_aux);
  p.push_back(prod_aux);

  // 23. method_declaration_final
  consecuente_aux.clear();
  consecuente_aux.push_back(S_23_1);
  consecuente_aux.push_back(NT_STATMENT_BLOCK);
  consecuente_aux.push_back(S_23_0);  
  consecuente_aux.push_back(G_23_0); 
  prod_aux.Set(NT_METHOD_DECLARATION_FINAL, consecuente_aux);
  p.push_back(prod_aux);
  
  // 24. method_declaration_final
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_24_0);  
  consecuente_aux.push_back(G_24_0); 
  prod_aux.Set(NT_METHOD_DECLARATION_FINAL, consecuente_aux);
  p.push_back(prod_aux);

  // 25. type
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_TYPE_SPECIFIER);
  consecuente_aux.push_back(NT_LISTA_CORCHETES);
  consecuente_aux.push_back(S_25_0); 
  consecuente_aux.push_back(G_25_0);
  prod_aux.Set(NT_TYPE, consecuente_aux);
  p.push_back(prod_aux);

  // 26. type_specifier
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_VOID);
  consecuente_aux.push_back(S_26_0);
  consecuente_aux.push_back(G_26_0); 
  prod_aux.Set(NT_TYPE_SPECIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 27. type_specifier
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_BOOLEAN);
  consecuente_aux.push_back(S_27_0); 
  consecuente_aux.push_back(G_27_0); 
  prod_aux.Set(NT_TYPE_SPECIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 28. type_specifier
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_INT);
  consecuente_aux.push_back(S_28_0); 
  consecuente_aux.push_back(G_28_0); 
  prod_aux.Set(NT_TYPE_SPECIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 29. type_specifier
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_29_0); 
  consecuente_aux.push_back(G_29_0); 
  prod_aux.Set(NT_TYPE_SPECIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 30. class_name
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_30_0);  
  consecuente_aux.push_back(G_30_0); 
  prod_aux.Set(NT_CLASS_NAME, consecuente_aux);
  p.push_back(prod_aux);

  // 31. parameter_list
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_PARAMETER);
  consecuente_aux.push_back(S_31_1);
  consecuente_aux.push_back(NT_LISTA_PARAMETER_LIST);
  consecuente_aux.push_back(S_31_0); 
  consecuente_aux.push_back(G_31_0); 
  prod_aux.Set(NT_PARAMETER_LIST, consecuente_aux);
  p.push_back(prod_aux);

  // 32. lista_parameter_list
  consecuente_aux.clear();
  consecuente_aux.push_back(T_COMA);
  consecuente_aux.push_back(NT_PARAMETER);
  consecuente_aux.push_back(S_32_1);
  consecuente_aux.push_back(NT_LISTA_PARAMETER_LIST);
  consecuente_aux.push_back(S_32_0); 
  consecuente_aux.push_back(G_32_0); 
  prod_aux.Set(NT_LISTA_PARAMETER_LIST, consecuente_aux);
  p.push_back(prod_aux);

  // 33. lista_parameter_list
  consecuente_aux.clear();
  consecuente_aux.push_back(S_33_0);  
  consecuente_aux.push_back(G_33_0); 
  prod_aux.Set(NT_LISTA_PARAMETER_LIST, consecuente_aux);
  p.push_back(prod_aux);

  // 34. parameter
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_TYPE);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_34_1);
  consecuente_aux.push_back(NT_LISTA_CORCHETES);
  consecuente_aux.push_back(S_34_0); 
  consecuente_aux.push_back(G_34_0); 
  prod_aux.Set(NT_PARAMETER, consecuente_aux);
  p.push_back(prod_aux);
  
  // 35. statment_block
  consecuente_aux.clear();
  consecuente_aux.push_back(T_LLAVES_ABRIR);
  consecuente_aux.push_back(S_35_1);
  consecuente_aux.push_back(NT_LISTA_STATMENT);  
  consecuente_aux.push_back(T_LLAVES_CERRAR);
  consecuente_aux.push_back(S_35_0); 
  consecuente_aux.push_back(G_35_0);
  prod_aux.Set(NT_STATMENT_BLOCK, consecuente_aux);
  p.push_back(prod_aux);

  // 36. lista_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_36_2);
  consecuente_aux.push_back(NT_STATMENT);
  consecuente_aux.push_back(S_36_1);
  consecuente_aux.push_back(NT_LISTA_STATMENT);
  consecuente_aux.push_back(S_36_0); 
  consecuente_aux.push_back(G_36_0); 
  prod_aux.Set(NT_LISTA_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 37. lista_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_37_0); 
  consecuente_aux.push_back(G_37_0); 
  prod_aux.Set(NT_LISTA_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 38. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_38_1);
  consecuente_aux.push_back(NT_POSIBLE_STATMENT);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_38_0);
  consecuente_aux.push_back(G_38_0); 
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 39. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_VOID);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_39_1);
  consecuente_aux.push_back(NT_VARIABLE_DECLARATION);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_39_0); 
  consecuente_aux.push_back(G_39_0);
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 40. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_INT);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_40_1);
  consecuente_aux.push_back(NT_VARIABLE_DECLARATION);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_40_0); 
  consecuente_aux.push_back(G_40_0);
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 41. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_BOOLEAN);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_41_1);
  consecuente_aux.push_back(NT_VARIABLE_DECLARATION);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_41_0); 
  consecuente_aux.push_back(G_41_0);
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 42. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_42_1);
  consecuente_aux.push_back(NT_STATMENT_BLOCK);
  consecuente_aux.push_back(S_42_0); 
  consecuente_aux.push_back(G_42_0); 
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 43. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_43_1);
  consecuente_aux.push_back(NT_DO_STATMENT);
  consecuente_aux.push_back(S_43_0); 
  consecuente_aux.push_back(G_43_0); 
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 44. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_RETURN);
  consecuente_aux.push_back(S_44_1);
  consecuente_aux.push_back(NT_OPCIONAL_EXPRESION);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_44_0); 
  consecuente_aux.push_back(G_44_0);
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 45. statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_45_0); 
  consecuente_aux.push_back(G_45_0); 
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 46. opcional_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(S_46_1);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(S_46_0);  
  consecuente_aux.push_back(G_46_0); 
  prod_aux.Set(NT_OPCIONAL_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 47 opcional_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(S_47_0);  
  consecuente_aux.push_back(G_47_0); 
  prod_aux.Set(NT_OPCIONAL_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 48. variable_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(S_48_2);  
  consecuente_aux.push_back(NT_VARIABLE_DECLARATOR);
  consecuente_aux.push_back(S_48_1);  
  consecuente_aux.push_back(NT_LISTA_VARIABLE_DECLARATOR);
  consecuente_aux.push_back(S_48_0);  
  consecuente_aux.push_back(G_48_0); 
  prod_aux.Set(NT_VARIABLE_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);

  // 49. lista_variable_declarator
  consecuente_aux.clear();
  consecuente_aux.push_back(T_COMA);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_49_2);
  consecuente_aux.push_back(NT_VARIABLE_DECLARATOR);
  consecuente_aux.push_back(S_49_1);
  consecuente_aux.push_back(NT_LISTA_VARIABLE_DECLARATOR);
  consecuente_aux.push_back(S_49_0); 
  consecuente_aux.push_back(G_49_0); 
  prod_aux.Set(NT_LISTA_VARIABLE_DECLARATOR, consecuente_aux);
  p.push_back(prod_aux);

  // 50. lista_variable_declarator
  consecuente_aux.clear();
  consecuente_aux.push_back(S_50_0); 
  consecuente_aux.push_back(G_50_0); 
  prod_aux.Set(NT_LISTA_VARIABLE_DECLARATOR, consecuente_aux);
  p.push_back(prod_aux);
  
  // 51. variable_declarator
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_LISTA_CORCHETES);
  consecuente_aux.push_back(S_51_1);
  consecuente_aux.push_back(NT_OPCIONAL_VARIABLE_INITIALIZER);
  consecuente_aux.push_back(S_51_0); 
  consecuente_aux.push_back(G_51_0); 
  prod_aux.Set(NT_VARIABLE_DECLARATOR, consecuente_aux);
  p.push_back(prod_aux);

  // 52. opcional_variable_initializer
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_ASIGNACION);
  consecuente_aux.push_back(NT_VARIABLE_INITIALIZER);
  consecuente_aux.push_back(S_52_0); 
  consecuente_aux.push_back(G_52_0); 
  prod_aux.Set(NT_OPCIONAL_VARIABLE_INITIALIZER, consecuente_aux);
  p.push_back(prod_aux);

  // 53. opcional_variable_initializer
  consecuente_aux.clear();
  consecuente_aux.push_back(S_53_0);  
  consecuente_aux.push_back(G_53_0); 
  prod_aux.Set(NT_OPCIONAL_VARIABLE_INITIALIZER, consecuente_aux);
  p.push_back(prod_aux);

  // 54. variable_initializer
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(S_54_0);  
  consecuente_aux.push_back(G_54_0); 
  prod_aux.Set(NT_VARIABLE_INITIALIZER, consecuente_aux);
  p.push_back(prod_aux);

  // 55. expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(S_55_2);
  consecuente_aux.push_back(NT_EXPRESION_1);
  consecuente_aux.push_back(S_55_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_55_0); 
  consecuente_aux.push_back(G_55_0); 
  prod_aux.Set(NT_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 56. expresion_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_OP_INDECREMENTO);
  consecuente_aux.push_back(S_56_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_56_0); 
  consecuente_aux.push_back(G_56_0); 
  prod_aux.Set(NT_EXPRESION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);
  
  // 57. expresion_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_OP_ARITMETICO);
  consecuente_aux.push_back(S_57_2);
  consecuente_aux.push_back(NT_EXPRESION_1);
  consecuente_aux.push_back(S_57_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_57_0);  
  consecuente_aux.push_back(G_57_0); 
  prod_aux.Set(NT_EXPRESION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);


  // 58. expresion_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_OP_RELACIONAL);
  consecuente_aux.push_back(S_58_2);
  consecuente_aux.push_back(NT_EXPRESION_1);
  consecuente_aux.push_back(S_58_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_58_0); 
  consecuente_aux.push_back(G_58_0); 
  prod_aux.Set(NT_EXPRESION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 59. expresion_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_OP_LOGICO);
  consecuente_aux.push_back(S_59_2);
  consecuente_aux.push_back(NT_EXPRESION_1);
  consecuente_aux.push_back(S_59_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_59_0); 
  consecuente_aux.push_back(G_59_0); 
  prod_aux.Set(NT_EXPRESION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 60. expresion_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_60_2);
  consecuente_aux.push_back(T_OP_MIEMBRO);
  consecuente_aux.push_back(NT_EXPRESION_1);
  consecuente_aux.push_back(S_60_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_60_0);  
  consecuente_aux.push_back(G_60_0);
  prod_aux.Set(NT_EXPRESION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 61. expresion_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_61_0);  
  consecuente_aux.push_back(G_61_0); 
  prod_aux.Set(NT_EXPRESION_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 62. expresion_1
  consecuente_aux.clear();
  consecuente_aux.push_back(S_62_2);
  consecuente_aux.push_back(NT_EXPRESION_2);
  consecuente_aux.push_back(S_62_1);
  consecuente_aux.push_back(NT_EXPRESION_1_PRIMA);
  consecuente_aux.push_back(S_62_0);  
  consecuente_aux.push_back(G_62_0); 
  prod_aux.Set(NT_EXPRESION_1, consecuente_aux);
  p.push_back(prod_aux);

  // 63. expresion_1_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_63_2);
  consecuente_aux.push_back(NT_EXPRESION_3);
  consecuente_aux.push_back(S_63_1);
  consecuente_aux.push_back(NT_EXPRESION_1_PRIMA);
  consecuente_aux.push_back(S_63_0);  
  consecuente_aux.push_back(G_63_0); 
  prod_aux.Set(NT_EXPRESION_1_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 64. expresion_1_prima
  consecuente_aux.clear();
  consecuente_aux.push_back(S_64_0);  
  consecuente_aux.push_back(G_64_0); 
  prod_aux.Set(NT_EXPRESION_1_PRIMA, consecuente_aux);
  p.push_back(prod_aux);

  // 65. expresion_2
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_CONSTANTE_LOGICA);
  consecuente_aux.push_back(S_65_0); 
  consecuente_aux.push_back(G_65_0); 
  prod_aux.Set(NT_EXPRESION_2, consecuente_aux);
  p.push_back(prod_aux);

  // 66. expresion_2
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_LITERAL_EXPRESION);
  consecuente_aux.push_back(S_66_0);   
  consecuente_aux.push_back(G_66_0); 
  prod_aux.Set(NT_EXPRESION_2, consecuente_aux);
  p.push_back(prod_aux);

  // 67. expresion_2
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_67_0); 
  consecuente_aux.push_back(G_67_0); 
  prod_aux.Set(NT_EXPRESION_2, consecuente_aux);
  p.push_back(prod_aux);

  // 68. expresion_2
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PARENTESIS_ABRIR);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(T_PARENTESIS_CERRAR);
  consecuente_aux.push_back(S_68_0);
  consecuente_aux.push_back(G_68_0); 
  prod_aux.Set(NT_EXPRESION_2, consecuente_aux);
  p.push_back(prod_aux);

  // 69. expresion_3
  consecuente_aux.clear();
  consecuente_aux.push_back(S_69_1);
  consecuente_aux.push_back(NT_AGRUPA_EXPRESION);
  consecuente_aux.push_back(S_69_0); 
  consecuente_aux.push_back(G_69_0); 
  prod_aux.Set(NT_EXPRESION_3, consecuente_aux);
  p.push_back(prod_aux);

  // 70. op_indecremento
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_INCREMENTO);
  consecuente_aux.push_back(S_70_0);  
  consecuente_aux.push_back(G_70_0); 
  prod_aux.Set(NT_OP_INDECREMENTO, consecuente_aux);
  p.push_back(prod_aux);

  // 71. op_indecremento
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_DECREMENTO);
  consecuente_aux.push_back(S_71_0);   
  consecuente_aux.push_back(G_71_0); 
  prod_aux.Set(NT_OP_INDECREMENTO, consecuente_aux);
  p.push_back(prod_aux);

  // 72. op_aritmetico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MAS);
  consecuente_aux.push_back(S_72_0);  
  consecuente_aux.push_back(G_72_0); 
  prod_aux.Set(NT_OP_ARITMETICO, consecuente_aux);
  p.push_back(prod_aux);

  // 73. op_aritmetico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MENOS);
  consecuente_aux.push_back(S_73_0);   
  consecuente_aux.push_back(G_73_0); 
  prod_aux.Set(NT_OP_ARITMETICO, consecuente_aux);
  p.push_back(prod_aux);

  // 74. op_aritmetico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_POR);
  consecuente_aux.push_back(S_74_0);   
  consecuente_aux.push_back(G_74_0); 
  prod_aux.Set(NT_OP_ARITMETICO, consecuente_aux);
  p.push_back(prod_aux);

  // 75. op_aritmetico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_DIVIDIR);
  consecuente_aux.push_back(S_75_0);   
  consecuente_aux.push_back(G_75_0); 
  prod_aux.Set(NT_OP_ARITMETICO, consecuente_aux);
  p.push_back(prod_aux);

  // 76. op_aritmetico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MODULO);
  consecuente_aux.push_back(S_76_0);   
  consecuente_aux.push_back(G_76_0); 
  prod_aux.Set(NT_OP_ARITMETICO, consecuente_aux);
  p.push_back(prod_aux);

  // 77. op_relacional
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MAYOR);
  consecuente_aux.push_back(S_77_0);  
  consecuente_aux.push_back(G_77_0); 
  prod_aux.Set(NT_OP_RELACIONAL, consecuente_aux);
  p.push_back(prod_aux);

  // 78. op_relacional
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MENOR);
  consecuente_aux.push_back(S_78_0); 
  consecuente_aux.push_back(G_78_0); 
  prod_aux.Set(NT_OP_RELACIONAL, consecuente_aux);
  p.push_back(prod_aux);

  // 79. op_relacional
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MAYOR_IGUAL);
  consecuente_aux.push_back(S_79_0); 
  consecuente_aux.push_back(G_79_0); 
  prod_aux.Set(NT_OP_RELACIONAL, consecuente_aux);
  p.push_back(prod_aux);

  // 80. op_relacional
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_MENOR_IGUAL);
  consecuente_aux.push_back(S_80_0);  
  consecuente_aux.push_back(G_80_0); 
  prod_aux.Set(NT_OP_RELACIONAL, consecuente_aux);
  p.push_back(prod_aux);

  // 81. op_relacional
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_IGUAL_IGUAL);
  consecuente_aux.push_back(S_81_0);   
  consecuente_aux.push_back(G_81_0); 
  prod_aux.Set(NT_OP_RELACIONAL, consecuente_aux);
  p.push_back(prod_aux);

  // 82. op_relacional
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_DISTINTO);
  consecuente_aux.push_back(S_82_0);   
  consecuente_aux.push_back(G_82_0); 
  prod_aux.Set(NT_OP_RELACIONAL, consecuente_aux);
  p.push_back(prod_aux);

  // 83. op_logico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_OR);
  consecuente_aux.push_back(S_83_0);  
  consecuente_aux.push_back(G_83_0); 
  prod_aux.Set(NT_OP_LOGICO, consecuente_aux);
  p.push_back(prod_aux);

  // 84. op_logico
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_AND);
  consecuente_aux.push_back(S_84_0);  
  consecuente_aux.push_back(G_84_0); 
  prod_aux.Set(NT_OP_LOGICO, consecuente_aux);
  p.push_back(prod_aux);

  // 85. agrupa_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PARENTESIS_ABRIR);
  consecuente_aux.push_back(S_85_1);
  consecuente_aux.push_back(NT_OPCIONAL_ARGLIST);
  consecuente_aux.push_back(T_PARENTESIS_CERRAR);
  consecuente_aux.push_back(S_85_0);   
  consecuente_aux.push_back(G_85_0); 
  prod_aux.Set(NT_AGRUPA_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 86. agrupa_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(T_CORCHETES_ABRIR);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(T_CORCHETES_CERRAR);
  consecuente_aux.push_back(S_86_0);  
  consecuente_aux.push_back(G_86_0);
  prod_aux.Set(NT_AGRUPA_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 87. opcional_arglist
  consecuente_aux.clear();
  consecuente_aux.push_back(S_87_1);
  consecuente_aux.push_back(NT_ARGLIST);
  consecuente_aux.push_back(S_87_0);   
  consecuente_aux.push_back(G_87_0); 
  prod_aux.Set(NT_OPCIONAL_ARGLIST, consecuente_aux);
  p.push_back(prod_aux);

  // 88. opcional_arglist
  consecuente_aux.clear();
  consecuente_aux.push_back(S_88_0);   
  consecuente_aux.push_back(G_88_0); 
  prod_aux.Set(NT_OPCIONAL_ARGLIST, consecuente_aux);
  p.push_back(prod_aux);

  // 89. literal_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_INTEGER_LITERAL);
  consecuente_aux.push_back(S_89_0);   
  consecuente_aux.push_back(G_89_0); 
  prod_aux.Set(NT_LITERAL_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 90. literal_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_STRING);
  consecuente_aux.push_back(S_90_0);   
  consecuente_aux.push_back(G_90_0);
  prod_aux.Set(NT_LITERAL_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 91. integer_literal
  consecuente_aux.clear();
  consecuente_aux.push_back(S_91_0);  
  consecuente_aux.push_back(G_91_0); 
  prod_aux.Set(NT_INTEGER_LITERAL, consecuente_aux);
  p.push_back(prod_aux);

  // 92. integer_literal
  consecuente_aux.clear();
  consecuente_aux.push_back(S_92_0);  
  consecuente_aux.push_back(G_92_0); 
  prod_aux.Set(NT_INTEGER_LITERAL, consecuente_aux);
  p.push_back(prod_aux);

  // 93. integer_literal
  consecuente_aux.clear();
  consecuente_aux.push_back(S_93_0);   
  consecuente_aux.push_back(G_93_0); 
  prod_aux.Set(NT_INTEGER_LITERAL, consecuente_aux);
  p.push_back(prod_aux);

  // 94. string
  consecuente_aux.clear();
  consecuente_aux.push_back(S_94_0);  
  consecuente_aux.push_back(G_94_0); 
  prod_aux.Set(NT_STRING, consecuente_aux);
  p.push_back(prod_aux);

  // 95. arglist
  consecuente_aux.clear();
  consecuente_aux.push_back(S_95_2);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(S_95_1);
  consecuente_aux.push_back(NT_LISTA_EXPRESION);
  consecuente_aux.push_back(S_95_0);  
  consecuente_aux.push_back(G_95_0);
  prod_aux.Set(NT_ARGLIST, consecuente_aux);
  p.push_back(prod_aux);

  // 96. lista_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(T_COMA);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(S_96_1);
  consecuente_aux.push_back(NT_LISTA_EXPRESION);
  consecuente_aux.push_back(S_96_0);  
  consecuente_aux.push_back(G_96_0); 
  prod_aux.Set(NT_LISTA_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 97. lista_expresion
  consecuente_aux.clear();
  consecuente_aux.push_back(S_97_0);   
  consecuente_aux.push_back(G_97_0); 
  prod_aux.Set(NT_LISTA_EXPRESION, consecuente_aux);
  p.push_back(prod_aux);

  // 98. do_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_DO);
  consecuente_aux.push_back(S_98_3);
  consecuente_aux.push_back(NT_STATMENT);
  consecuente_aux.push_back(T_WHILE);
  consecuente_aux.push_back(T_PARENTESIS_ABRIR);
  consecuente_aux.push_back(S_98_2);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(S_98_1);
  consecuente_aux.push_back(T_PARENTESIS_CERRAR);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_98_0); 
  consecuente_aux.push_back(G_98_0); 
  prod_aux.Set(NT_DO_STATMENT, consecuente_aux);
  p.push_back(prod_aux);
 
  // 99. constructor_declaration
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PARENTESIS_ABRIR);
  consecuente_aux.push_back(S_99_2);
  consecuente_aux.push_back(NT_OPCIONAL_PARAMETER_LIST);
  consecuente_aux.push_back(T_PARENTESIS_CERRAR);
  consecuente_aux.push_back(S_99_1);
  consecuente_aux.push_back(NT_STATMENT_BLOCK);
  consecuente_aux.push_back(S_99_0);  
  consecuente_aux.push_back(G_99_0); 
  prod_aux.Set(NT_CONSTRUCTOR_DECLARATION, consecuente_aux);
  p.push_back(prod_aux);
  
  // 100. constante_logica
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TRUE);
  consecuente_aux.push_back(S_100_0); 
  consecuente_aux.push_back(G_100_0); 
  prod_aux.Set(NT_CONSTANTE_LOGICA, consecuente_aux);
  p.push_back(prod_aux);

  // 101. constante_logica
  consecuente_aux.clear();
  consecuente_aux.push_back(T_FALSE);
  consecuente_aux.push_back(S_101_0);  
  consecuente_aux.push_back(G_101_0); 
  prod_aux.Set(NT_CONSTANTE_LOGICA, consecuente_aux);
  p.push_back(prod_aux);

  // 102. opcional_identifier
  consecuente_aux.clear();
  consecuente_aux.push_back(S_102_2);
  consecuente_aux.push_back(T_OP_MIEMBRO);
  consecuente_aux.push_back(S_102_1);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_102_0);  
  consecuente_aux.push_back(G_102_0); 
  prod_aux.Set(NT_OPCIONAL_IDENTIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 103 opcional_identifier
  consecuente_aux.clear();
  consecuente_aux.push_back(S_103_0);   
  consecuente_aux.push_back(G_103_0); 
  prod_aux.Set(NT_OPCIONAL_IDENTIFIER, consecuente_aux);
  p.push_back(prod_aux);

  // 104 op_asignacion
  consecuente_aux.clear();
  consecuente_aux.push_back(T_OP_ASIGNACION);
  consecuente_aux.push_back(S_104_0);   
  consecuente_aux.push_back(G_104_0); 
  prod_aux.Set(NT_OP_ASIGNACION, consecuente_aux);
  p.push_back(prod_aux);

  // 105 posible_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_105_1);
  consecuente_aux.push_back(NT_EXPRESION_PRIMA);
  consecuente_aux.push_back(S_105_0);
  consecuente_aux.push_back(G_105_0);
  prod_aux.Set(NT_POSIBLE_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 106 posible_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_106_1);
  consecuente_aux.push_back(NT_AGRUPA_EXPRESION);
  consecuente_aux.push_back(S_106_0);
  consecuente_aux.push_back(G_106_0);
  prod_aux.Set(NT_POSIBLE_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 107 posible_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(S_107_2);
  consecuente_aux.push_back(NT_OP_ASIGNACION);
  consecuente_aux.push_back(S_107_1);
  consecuente_aux.push_back(NT_EXPRESION);
  consecuente_aux.push_back(S_107_0);
  consecuente_aux.push_back(G_107_0);
  prod_aux.Set(NT_POSIBLE_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 108 posible_statment
  consecuente_aux.clear();
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(S_108_1);
  consecuente_aux.push_back(NT_VARIABLE_DECLARATION);
  consecuente_aux.push_back(S_108_0);
  consecuente_aux.push_back(G_108_0);
  prod_aux.Set(NT_POSIBLE_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 109 statment
  consecuente_aux.clear();
  consecuente_aux.push_back(T_CONST);
  consecuente_aux.push_back(NT_POSIBLE_CONST);
  consecuente_aux.push_back(T_PUNTO_Y_COMA);
  consecuente_aux.push_back(S_109_0);
  consecuente_aux.push_back(G_109_0);
  prod_aux.Set(NT_STATMENT, consecuente_aux);
  p.push_back(prod_aux);

  // 110 posible_const
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_INT);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(NT_OP_ASIGNACION);
  consecuente_aux.push_back(NT_INTEGER_LITERAL);
  consecuente_aux.push_back(S_110_0);
  consecuente_aux.push_back(G_110_0);
  prod_aux.Set(NT_POSIBLE_CONST, consecuente_aux);
  p.push_back(prod_aux);

  // 111 posible_const
  consecuente_aux.clear();
  consecuente_aux.push_back(T_TD_BOOLEAN);
  consecuente_aux.push_back(NT_IDENTIFIER);
  consecuente_aux.push_back(NT_OP_ASIGNACION);
  consecuente_aux.push_back(NT_CONSTANTE_LOGICA);
  consecuente_aux.push_back(S_111_0);
  consecuente_aux.push_back(G_111_0);
  prod_aux.Set(NT_POSIBLE_CONST, consecuente_aux);
  p.push_back(prod_aux);

  // 112 variable_declarator
  consecuente_aux.clear();
  consecuente_aux.push_back(T_PARENTESIS_ABRIR);
  consecuente_aux.push_back(NT_OPCIONAL_ARGLIST);
  consecuente_aux.push_back(T_PARENTESIS_CERRAR);
  consecuente_aux.push_back(S_112_0);
  consecuente_aux.push_back(G_112_0);
  prod_aux.Set(NT_VARIABLE_DECLARATOR, consecuente_aux);
  p.push_back(prod_aux);
}
