// $Id: CProduccion.hpp,v 1.11 2001/09/25 07:32:41 jpl Exp $

#if !defined( _CProduccion_HPP_ )
#define _CProduccion_HPP_

#include "data.hpp"

class CProduccion {
public:
  CProduccion(void);
  void Set(const string& a, const vector<string>& c);
  void Set_Lugar (string l);
  inline string Get_Lugar(void) const { return lugar; }
  void Set_Codigo (vector<string> c);
  void Add_Codigo (string c);
  inline vector<string> Get_Codigo(void) const { return codigo; }
  void Set_TProd (string c);
  inline string Get_TProd (void) const {return tprod; }
  void Set_PCodigo (vector<string> c);
  void Add_PCodigo (string c);
  inline vector<string> Get_PCodigo(void) const { return pcodigo; }
  void Set_LObjetos (vector<string> c);
  void Add_Objeto (string c);
  inline vector<string> Get_LObjetos(void) const { return lobjetos; }


  void Set_Acceso(TipoAcceso a) { acceso = a; }
  TipoAcceso Get_Acceso(void) const { return acceso; }
  void Set_Tipo(const string& t) { tipo = t; }
  string Get_Tipo(void) { return tipo; }
  void Set_Valor(const string& v) { valor = v; }
  string Get_Valor(void) const { return valor; }
  void Set_Clase(const string& c) { clase = c; }
  string Get_Clase(void) const { return clase; }
  void Set_NProduccion(int n) { n_produccion = n; }
  int Get_NProduccion(void) { return n_produccion; }
  inline unsigned int NSimbolos_Consecuente(void) { return consecuente.size(); }
  inline string Antecedente(void) const { return antecedente; }
  string operator[](unsigned int i) { return consecuente[i]; }
private:
  // Smbolos en la produccin.
  string         antecedente;
  vector<string> consecuente;

  //  union {
  //Tipo_Visibilidad visibilidad; // antecedente == modifier.
  //string           tipo;        // antecedente == (type_specifier|class_name)
  //  };

  // Atributos para la generacin de cdigo:
  string           lugar;       // Nombre de temporales o variables
  vector<string>   codigo;      // Codigo intermedio que se va acumulando
  vector<string>   pcodigo;     // Codigo que se inserta despus de un statment
  string           tprod;       // Tipo de produccin por la que deriva
  vector<string>   lobjetos;    // Lista de objetos declarados

  // Atributos para el analizador semntico.
  TipoAcceso acceso;
  string     tipo;       
  string     valor;
  string     clase;
  int        n_produccion;
};

typedef vector<CProduccion> Gramatica;
void Inicializar_Gramatica(Gramatica& p);

#endif // _CProduccion_HPP_
