// $Id: CTablaSimbolos.hpp,v 1.6 2001/09/24 04:26:37 jpl Exp $

#if !defined( _CTablaSimbolos_HPP_ )
#define _CTablaSimbolos_HPP_

#include <string>
#include <set>
#include <stack>
#include "CExcepciones.hpp"
#include "CLexema.hpp"

class CTablaSimbolos {
private:
  stack<CLexema> ambito;              // mbito de los lexemas + informacin.
  stack<int>     bloques;             // Bloques de mbito.
  set<string>    palabras_reservadas; // Palabras reservadas.                 
public:
  CTablaSimbolos(void);
  inline set<string> GetPalabrasReservadas(void) const { return palabras_reservadas; }
  void Inserta(const CLexema& lexema);
  bool Busca(const string& id_lexema) const;
  CLexema Recupera(const string& id_lexema) const;
  void Modifica(const CLexema& lexema);		
  void PushBloque(void);
  void PopBloque(void);  
};

#endif // _CTablaSimbolos_HPP_
