// $Id: data.cpp,v 1.28 2001/09/25 18:53:34 jpl Exp $

#include "data.hpp"

//
// INICIALIZAR_TERMINALES
//
void
Inicializar_Terminales(Terminales& ct)
{ 
  ct.insert(T_LLAVES_ABRIR); 
  ct.insert(T_LLAVES_CERRAR);
  ct.insert(T_PARENTESIS_ABRIR); 
  ct.insert(T_PARENTESIS_CERRAR);
  ct.insert(T_CORCHETES_ABRIR);  
  ct.insert(T_CORCHETES_CERRAR); 

  ct.insert(T_PUBLIC);      
  ct.insert(T_PRIVATE);    
  ct.insert(T_CLASS);       
  ct.insert(T_RETURN); 
  
  ct.insert(T_PUNTO_Y_COMA);
  ct.insert(T_OP_MIEMBRO);
  ct.insert(T_COMA);  
  ct.insert(T_OP_ASIGNACION);       
  
  ct.insert(T_TD_VOID);
  ct.insert(T_TD_BOOLEAN);         
  ct.insert(T_TD_INT);              
  
  ct.insert(T_OP_INCREMENTO);           
  ct.insert(T_OP_DECREMENTO);       
  
  ct.insert(T_TRUE);            
  ct.insert(T_FALSE);            
  
  ct.insert(T_OP_MAS);
  ct.insert(T_OP_MENOS);
  ct.insert(T_OP_POR);              
  ct.insert(T_OP_DIVIDIR);         
  ct.insert(T_OP_MODULO);
              
  ct.insert(T_OP_MAYOR);            
  ct.insert(T_OP_MENOR);            
  ct.insert(T_OP_MAYOR_IGUAL);      
  ct.insert(T_OP_MENOR_IGUAL);      
  ct.insert(T_OP_IGUAL_IGUAL);            
  ct.insert(T_OP_DISTINTO);        
  
  ct.insert(T_OP_AND);        
  ct.insert(T_OP_OR);      

  ct.insert(T_OP_ASIGNACION);

  ct.insert(T_DO);               
  ct.insert(T_WHILE);

  ct.insert(T_OCTAL);
  ct.insert(T_DECIMAL);
  ct.insert(T_HEXADECIMAL);

  ct.insert(T_CONST);
}

//
// INICIALIZAR_NOTERMINALES
//
void
Inicializar_NoTerminales(NoTerminales& cnt)
{
  cnt.insert(NT_COMPILATION_UNIT); 
  cnt.insert(NT_LISTA_TYPE_DECLARATION); 
  cnt.insert(NT_TYPE_DECLARATION); 
  cnt.insert(NT_CLASS_DECLARATION); 
  cnt.insert(NT_LISTA_FIELD_DECLARATION); 
  cnt.insert(NT_MODIFIER); 
  cnt.insert(NT_IDENTIFIER); 
  cnt.insert(NT_FIELD_DECLARATION); 
  cnt.insert(NT_FIELD_DECLARATION_PRIMA);
  cnt.insert(NT_FIELD_DECLARATION_PRIMA_PRIMA);
  cnt.insert(NT_METHOD_DECLARATION);
  cnt.insert(NT_OPCIONAL_PARAMETER_LIST);
  cnt.insert(NT_LISTA_CORCHETES);
  cnt.insert(NT_METHOD_DECLARATION_FINAL);
  cnt.insert(NT_TYPE);                   
  cnt.insert(NT_TYPE_SPECIFIER);         
  cnt.insert(NT_CLASS_NAME);             
  cnt.insert(NT_PARAMETER_LIST);
  cnt.insert(NT_LISTA_PARAMETER_LIST);
  cnt.insert(NT_PARAMETER);              
  cnt.insert(NT_STATMENT_BLOCK);  
  cnt.insert(NT_LISTA_STATMENT);
  cnt.insert(NT_STATMENT);
  cnt.insert(NT_OPCIONAL_EXPRESION);
  cnt.insert(NT_VARIABLE_DECLARATION);
  cnt.insert(NT_LISTA_VARIABLE_DECLARATOR);
  cnt.insert(NT_VARIABLE_DECLARATOR);
  cnt.insert(NT_OPCIONAL_VARIABLE_INITIALIZER);
  cnt.insert(NT_VARIABLE_INITIALIZER);    
  cnt.insert(NT_EXPRESION);              
  cnt.insert(NT_EXPRESION_PRIMA);         
  cnt.insert(NT_EXPRESION_1);
  cnt.insert(NT_EXPRESION_1_PRIMA);
  cnt.insert(NT_EXPRESION_2);      
  cnt.insert(NT_EXPRESION_2_PRIMA);
  cnt.insert(NT_EXPRESION_3);
  cnt.insert(NT_EXPRESION_3_PRIMA);
  cnt.insert(NT_EXPRESION_4);
  cnt.insert(NT_EXPRESION_5);
  cnt.insert(NT_OP_INDECREMENTO);
  cnt.insert(NT_OP_ARITMETICO);
  cnt.insert(NT_OP_RELACIONAL);
  cnt.insert(NT_OP_LOGICO);
  cnt.insert(NT_AGRUPA_EXPRESION);
  cnt.insert(NT_OPCIONAL_ARGLIST);
  cnt.insert(NT_LITERAL_EXPRESION);
  cnt.insert(NT_INTEGER_LITERAL);         
  cnt.insert(NT_STRING);                                 
  cnt.insert(NT_ARGLIST);                 
  cnt.insert(NT_LISTA_EXPRESION);
  cnt.insert(NT_DO_STATMENT);             
  cnt.insert(NT_CONSTRUCTOR_DECLARATION);
  cnt.insert(NT_CONSTANTE_LOGICA);
  cnt.insert(NT_OPCIONAL_IDENTIFIER);
  cnt.insert(NT_OP_ASIGNACION);
  cnt.insert(NT_POSIBLE_STATMENT);
  cnt.insert(NT_POSIBLE_CONST);
}

//
// INICIALIZAR_SIMBOLOSSEMANTICOS
//
void 
Inicializar_SimbolosSemanticos(SimbolosSemanticos& ss)
{
  ss.insert(S_1_0);
  ss.insert(S_1_1);
  ss.insert(S_2_0);
  ss.insert(S_3_0);
  ss.insert(S_4_0);
  ss.insert(S_5_0);
  ss.insert(S_5_1);
  ss.insert(S_5_2);
  ss.insert(S_6_0);
  ss.insert(S_6_1);
  ss.insert(S_6_2);
  ss.insert(S_7_0);
  ss.insert(S_8_0);
  ss.insert(S_9_0);
  ss.insert(S_10_0);
  ss.insert(S_11_0);
  ss.insert(S_12_0);
  ss.insert(S_12_1);
  ss.insert(S_13_0);
  ss.insert(S_14_0);
  ss.insert(S_14_1);
  ss.insert(S_15_0);
  ss.insert(S_15_1);
  ss.insert(S_16_0);
  ss.insert(S_16_1);
  ss.insert(S_17_0);
  ss.insert(S_17_1);
  ss.insert(S_18_0);
  ss.insert(S_18_1);
  ss.insert(S_18_2);
  ss.insert(S_19_0);
  ss.insert(S_19_1);
  ss.insert(S_20_0);
  ss.insert(S_21_0);
  ss.insert(S_22_0);
  ss.insert(S_23_0);
  ss.insert(S_23_1);
  ss.insert(S_24_0);    
  ss.insert(S_25_0);
  ss.insert(S_26_0);
  ss.insert(S_27_0);
  ss.insert(S_28_0);
  ss.insert(S_29_0);
  ss.insert(S_30_0);
  ss.insert(S_31_0);
  ss.insert(S_31_1);
  ss.insert(S_32_0);
  ss.insert(S_32_1);
  ss.insert(S_33_0);
  ss.insert(S_34_0);
  ss.insert(S_34_1);
  ss.insert(S_35_0);
  ss.insert(S_35_1);
  ss.insert(S_36_0);
  ss.insert(S_36_1);
  ss.insert(S_36_2);
  ss.insert(S_37_0);
  ss.insert(S_38_0);
  ss.insert(S_38_1);
  ss.insert(S_39_0);
  ss.insert(S_39_1);
  ss.insert(S_40_0);
  ss.insert(S_40_1);
  ss.insert(S_41_0);
  ss.insert(S_41_1);
  ss.insert(S_42_0);
  ss.insert(S_42_1);
  ss.insert(S_43_0);
  ss.insert(S_43_1);
  ss.insert(S_44_0);
  ss.insert(S_44_1);
  ss.insert(S_45_0);
  ss.insert(S_46_0);
  ss.insert(S_46_1);
  ss.insert(S_47_0);
  ss.insert(S_48_0);    
  ss.insert(S_48_1);    
  ss.insert(S_48_2);    
  ss.insert(S_49_0);
  ss.insert(S_49_1);
  ss.insert(S_49_2);
  ss.insert(S_50_0);
  ss.insert(S_51_0);
  ss.insert(S_51_1);
  ss.insert(S_52_0);
  ss.insert(S_53_0);
  ss.insert(S_54_0);
  ss.insert(S_55_0);
  ss.insert(S_55_1);
  ss.insert(S_55_2);
  ss.insert(S_56_0);
  ss.insert(S_56_1);
  ss.insert(S_57_0);
  ss.insert(S_57_1);
  ss.insert(S_57_2);
  ss.insert(S_58_0);
  ss.insert(S_58_1);
  ss.insert(S_58_2);
  ss.insert(S_59_0);
  ss.insert(S_59_1);
  ss.insert(S_59_2);
  ss.insert(S_60_0);
  ss.insert(S_60_1);
  ss.insert(S_60_2);
  ss.insert(S_61_0);
  ss.insert(S_62_0);
  ss.insert(S_62_1);
  ss.insert(S_62_2);
  ss.insert(S_63_0);
  ss.insert(S_63_1);
  ss.insert(S_63_2);
  ss.insert(S_64_0);
  ss.insert(S_65_0);
  ss.insert(S_66_0);
  ss.insert(S_67_0);
  ss.insert(S_68_0);
  ss.insert(S_69_0);
  ss.insert(S_69_1);
  ss.insert(S_70_0);
  ss.insert(S_71_0);
  ss.insert(S_72_0);    
  ss.insert(S_73_0);
  ss.insert(S_74_0);
  ss.insert(S_75_0);
  ss.insert(S_76_0);
  ss.insert(S_77_0);
  ss.insert(S_78_0);
  ss.insert(S_79_0);
  ss.insert(S_80_0);
  ss.insert(S_81_0);
  ss.insert(S_82_0);
  ss.insert(S_83_0);
  ss.insert(S_84_0);
  ss.insert(S_85_0);
  ss.insert(S_85_1);
  ss.insert(S_86_0);
  ss.insert(S_87_0);
  ss.insert(S_87_1);
  ss.insert(S_88_0);
  ss.insert(S_89_0);
  ss.insert(S_90_0);
  ss.insert(S_91_0);
  ss.insert(S_92_0);
  ss.insert(S_93_0);
  ss.insert(S_94_0);
  ss.insert(S_95_0);
  ss.insert(S_95_1);
  ss.insert(S_95_2);
  ss.insert(S_96_0);
  ss.insert(S_96_1);
  ss.insert(S_97_0);
  ss.insert(S_98_0);
  ss.insert(S_98_1);
  ss.insert(S_98_2);
  ss.insert(S_98_3);
  ss.insert(S_99_0);
  ss.insert(S_99_1);
  ss.insert(S_99_2);
  ss.insert(S_100_0);
  ss.insert(S_101_0);
  ss.insert(S_102_0);
  ss.insert(S_103_0);
  ss.insert(S_104_0);
  ss.insert(S_105_0);
  ss.insert(S_105_1);
  ss.insert(S_106_0);
  ss.insert(S_106_1);
  ss.insert(S_107_0);
  ss.insert(S_107_1);
  ss.insert(S_107_2);
  ss.insert(S_108_0);
  ss.insert(S_108_1);
  ss.insert(S_109_0);
  ss.insert(S_110_0);
  ss.insert(S_111_0);
  ss.insert(S_112_0);
}

//
// INICIALIZAR_SIMBOLOSGenCodigo
//
void 
Inicializar_SimbolosGenCodigo(SimbolosGenCodigo& sg)
{
  sg.insert(G_1_0);
  sg.insert(G_2_0);
  sg.insert(G_3_0);
  sg.insert(G_4_0);
  sg.insert(G_5_0);
  sg.insert(G_6_0);
  sg.insert(G_7_0);
  sg.insert(G_8_0);
  sg.insert(G_9_0);
  sg.insert(G_10_0);
  sg.insert(G_11_0);
  sg.insert(G_12_0);
  sg.insert(G_13_0);
  sg.insert(G_14_0);
  sg.insert(G_15_0);
  sg.insert(G_16_0);
  sg.insert(G_17_0);
  sg.insert(G_18_0);
  sg.insert(G_19_0);
  sg.insert(G_20_0);
  sg.insert(G_21_0);
  sg.insert(G_22_0);
  sg.insert(G_23_0);
  sg.insert(G_24_0);    
  sg.insert(G_25_0);
  sg.insert(G_26_0);
  sg.insert(G_27_0);
  sg.insert(G_28_0);
  sg.insert(G_29_0);
  sg.insert(G_30_0);
  sg.insert(G_31_0);
  sg.insert(G_32_0);
  sg.insert(G_33_0);
  sg.insert(G_34_0);
  sg.insert(G_35_0);
  sg.insert(G_36_0);
  sg.insert(G_37_0);
  sg.insert(G_38_0);
  sg.insert(G_39_0);
  sg.insert(G_40_0);
  sg.insert(G_41_0);
  sg.insert(G_42_0);
  sg.insert(G_43_0);
  sg.insert(G_44_0);
  sg.insert(G_45_0);
  sg.insert(G_46_0);
  sg.insert(G_47_0);
  sg.insert(G_48_0);    
  sg.insert(G_49_0);
  sg.insert(G_50_0);
  sg.insert(G_51_0);
  sg.insert(G_52_0);
  sg.insert(G_53_0);
  sg.insert(G_54_0);
  sg.insert(G_55_0);
  sg.insert(G_56_0);
  sg.insert(G_57_0);
  sg.insert(G_58_0);
  sg.insert(G_59_0);
  sg.insert(G_60_0);
  sg.insert(G_61_0);
  sg.insert(G_62_0);
  sg.insert(G_63_0);
  sg.insert(G_64_0);
  sg.insert(G_65_0);
  sg.insert(G_66_0);
  sg.insert(G_67_0);
  sg.insert(G_68_0);
  sg.insert(G_69_0);
  sg.insert(G_70_0);
  sg.insert(G_71_0);
  sg.insert(G_72_0);    
  sg.insert(G_73_0);
  sg.insert(G_74_0);
  sg.insert(G_75_0);
  sg.insert(G_76_0);
  sg.insert(G_77_0);
  sg.insert(G_78_0);
  sg.insert(G_79_0);
  sg.insert(G_80_0);
  sg.insert(G_81_0);
  sg.insert(G_82_0);
  sg.insert(G_83_0);
  sg.insert(G_84_0);
  sg.insert(G_85_0);
  sg.insert(G_86_0);
  sg.insert(G_87_0);
  sg.insert(G_88_0);
  sg.insert(G_89_0);
  sg.insert(G_90_0);
  sg.insert(G_91_0);
  sg.insert(G_92_0);
  sg.insert(G_93_0);
  sg.insert(G_94_0);
  sg.insert(G_95_0);
  sg.insert(G_96_0);
  sg.insert(G_97_0);
  sg.insert(G_98_0);
  sg.insert(G_99_0);
  sg.insert(G_100_0);
  sg.insert(G_101_0);
  sg.insert(G_102_0);
  sg.insert(G_103_0);
  sg.insert(G_104_0);
  sg.insert(G_105_0);
  sg.insert(G_106_0);
  sg.insert(G_107_0);
  sg.insert(G_108_0);
  sg.insert(G_109_0);
  sg.insert(G_110_0);
  sg.insert(G_111_0);
  sg.insert(G_112_0);
}


void
Inicializar_TablaAS(TablaAS& tas)
{
  tas[NT_COMPILATION_UNIT][PUBLIC] = 1;
  tas[NT_COMPILATION_UNIT][PRIVATE] = 1;
  tas[NT_COMPILATION_UNIT][CLASS] = 1;

  tas[NT_LISTA_TYPE_DECLARATION][PUBLIC] = 2;
  tas[NT_LISTA_TYPE_DECLARATION][PRIVATE] = 2;
  tas[NT_LISTA_TYPE_DECLARATION][CLASS] = 2;
  tas[NT_LISTA_TYPE_DECLARATION][$] = 3;

  tas[NT_TYPE_DECLARATION][PUBLIC] = 4;
  tas[NT_TYPE_DECLARATION][PRIVATE] = 4;
  tas[NT_TYPE_DECLARATION][CLASS] = 4;

  tas[NT_CLASS_DECLARATION][PUBLIC] = 5;
  tas[NT_CLASS_DECLARATION][PRIVATE] = 5;
  tas[NT_CLASS_DECLARATION][CLASS] = 5;

  tas[NT_LISTA_FIELD_DECLARATION][PUBLIC] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][PRIVATE] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][TD_VOID] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][TD_BOOLEAN] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][TD_ENTERO] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][IDENTIFICADOR] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][PUNTO_Y_COMA] = 6;
  tas[NT_LISTA_FIELD_DECLARATION][LLAVES_CERRAR] = 7;

  tas[NT_MODIFIER][PUBLIC] = 8;
  tas[NT_MODIFIER][PRIVATE] = 9;
  tas[NT_MODIFIER][CLASS] = 10;
  tas[NT_MODIFIER][TD_VOID] = 10;
  tas[NT_MODIFIER][TD_BOOLEAN] = 10;
  tas[NT_MODIFIER][TD_ENTERO] = 10;
  tas[NT_MODIFIER][IDENTIFICADOR] = 10;

  tas[NT_IDENTIFIER][IDENTIFICADOR] = 11;

  tas[NT_FIELD_DECLARATION][PUBLIC] = 12;
  tas[NT_FIELD_DECLARATION][PRIVATE] = 12;
  tas[NT_FIELD_DECLARATION][TD_VOID] = 12;
  tas[NT_FIELD_DECLARATION][TD_ENTERO] = 12;
  tas[NT_FIELD_DECLARATION][TD_BOOLEAN] = 12;
  tas[NT_FIELD_DECLARATION][IDENTIFICADOR] = 12;
  tas[NT_FIELD_DECLARATION][PUNTO_Y_COMA] = 13;

  tas[NT_FIELD_DECLARATION_PRIMA][PARENTESIS_ABRIR] = 14;
  tas[NT_FIELD_DECLARATION_PRIMA][IDENTIFICADOR] = 15;

  tas[NT_FIELD_DECLARATION_PRIMA_PRIMA][CORCHETES_ABRIR] = 16;
  tas[NT_FIELD_DECLARATION_PRIMA_PRIMA][COMA] = 16;
  tas[NT_FIELD_DECLARATION_PRIMA_PRIMA][PUNTO_Y_COMA] = 16;
  tas[NT_FIELD_DECLARATION_PRIMA_PRIMA][PARENTESIS_ABRIR] = 17;
  
  tas[NT_METHOD_DECLARATION][PARENTESIS_ABRIR] = 18;

  tas[NT_OPCIONAL_PARAMETER_LIST][IDENTIFICADOR] = 19;
  tas[NT_OPCIONAL_PARAMETER_LIST][TD_VOID] = 19;
  tas[NT_OPCIONAL_PARAMETER_LIST][TD_BOOLEAN] = 19;
  tas[NT_OPCIONAL_PARAMETER_LIST][TD_ENTERO] = 19;
  tas[NT_OPCIONAL_PARAMETER_LIST][PARENTESIS_CERRAR] = 20;

  tas[NT_LISTA_CORCHETES][CORCHETES_ABRIR] = 21;
  tas[NT_LISTA_CORCHETES][PARENTESIS_ABRIR] = 22;
  tas[NT_LISTA_CORCHETES][IDENTIFICADOR] = 22;
  tas[NT_LISTA_CORCHETES][PARENTESIS_CERRAR] = 22;
  tas[NT_LISTA_CORCHETES][COMA] = 22;
  tas[NT_LISTA_CORCHETES][PUNTO_Y_COMA] = 22;
  tas[NT_LISTA_CORCHETES][LLAVES_ABRIR] = 22;
  tas[NT_LISTA_CORCHETES][OP_ASIGNACION] = 22;

  tas[NT_METHOD_DECLARATION_FINAL][LLAVES_ABRIR] = 23;
  tas[NT_METHOD_DECLARATION_FINAL][PUNTO_Y_COMA] = 24;

  tas[NT_TYPE][IDENTIFICADOR] = 25;
  tas[NT_TYPE][TD_VOID] = 25;
  tas[NT_TYPE][TD_BOOLEAN] = 25;
  tas[NT_TYPE][TD_ENTERO] = 25;

  tas[NT_TYPE_SPECIFIER][TD_VOID] = 26;
  tas[NT_TYPE_SPECIFIER][TD_BOOLEAN] = 27;
  tas[NT_TYPE_SPECIFIER][TD_ENTERO] = 28;
  tas[NT_TYPE_SPECIFIER][IDENTIFICADOR] = 29;
  
  tas[NT_CLASS_NAME][IDENTIFICADOR] = 30;

  tas[NT_PARAMETER_LIST][TD_VOID] = 31;
  tas[NT_PARAMETER_LIST][TD_BOOLEAN] = 31;
  tas[NT_PARAMETER_LIST][TD_ENTERO] = 31;
  tas[NT_PARAMETER_LIST][IDENTIFICADOR] = 31;

  tas[NT_LISTA_PARAMETER_LIST][COMA] = 32;
  tas[NT_LISTA_PARAMETER_LIST][PARENTESIS_CERRAR] = 33;

  tas[NT_PARAMETER][TD_VOID] = 34;
  tas[NT_PARAMETER][TD_BOOLEAN] = 34;
  tas[NT_PARAMETER][TD_ENTERO] = 34;
  tas[NT_PARAMETER][IDENTIFICADOR] = 34;

  tas[NT_STATMENT_BLOCK][LLAVES_ABRIR] = 35;

  tas[NT_LISTA_STATMENT][IDENTIFICADOR] = 36;
  tas[NT_LISTA_STATMENT][TRUE] = 36;
  tas[NT_LISTA_STATMENT][FALSE] = 36;
  tas[NT_LISTA_STATMENT][OCTAL] = 36;
  tas[NT_LISTA_STATMENT][DECIMAL] = 36;
  tas[NT_LISTA_STATMENT][HEXADECIMAL] = 36;
  tas[NT_LISTA_STATMENT][CADENA_CARACTERES] = 36;
  tas[NT_LISTA_STATMENT][PARENTESIS_ABRIR] = 36;
  tas[NT_LISTA_STATMENT][LLAVES_ABRIR] = 36;
  tas[NT_LISTA_STATMENT][DO] = 36;
  tas[NT_LISTA_STATMENT][RETURN] = 36;
  tas[NT_LISTA_STATMENT][PUNTO_Y_COMA] = 36;
  tas[NT_LISTA_STATMENT][TD_ENTERO] = 36;
  tas[NT_LISTA_STATMENT][TD_VOID] = 36;
  tas[NT_LISTA_STATMENT][TD_BOOLEAN] = 36;
  tas[NT_LISTA_STATMENT][CONST] = 36;
  tas[NT_LISTA_STATMENT][LLAVES_CERRAR] = 37;


  tas[NT_STATMENT][IDENTIFICADOR] = 38;
  tas[NT_STATMENT][TD_VOID] = 39;
  tas[NT_STATMENT][TD_ENTERO] = 40;
  tas[NT_STATMENT][TD_BOOLEAN] = 41;
  tas[NT_STATMENT][LLAVES_ABRIR] = 42;
  tas[NT_STATMENT][DO] = 43;
  tas[NT_STATMENT][RETURN] = 44;
  tas[NT_STATMENT][PUNTO_Y_COMA] = 45;
  tas[NT_STATMENT][CONST] = 109;

  tas[NT_OPCIONAL_EXPRESION][TRUE] = 46;
  tas[NT_OPCIONAL_EXPRESION][FALSE] = 46;
  tas[NT_OPCIONAL_EXPRESION][DECIMAL] = 46;
  tas[NT_OPCIONAL_EXPRESION][OCTAL] = 46;
  tas[NT_OPCIONAL_EXPRESION][HEXADECIMAL] = 46;
  tas[NT_OPCIONAL_EXPRESION][CADENA_CARACTERES] = 46;
  tas[NT_OPCIONAL_EXPRESION][IDENTIFICADOR] = 46;
  tas[NT_OPCIONAL_EXPRESION][PARENTESIS_ABRIR] = 46;
  tas[NT_OPCIONAL_EXPRESION][PUNTO_Y_COMA] = 47;

  tas[NT_VARIABLE_DECLARATION][CORCHETES_ABRIR] = 48;
  tas[NT_VARIABLE_DECLARATION][PARENTESIS_ABRIR] = 48;
  tas[NT_VARIABLE_DECLARATION][IDENTIFICADOR] = 48;
  tas[NT_VARIABLE_DECLARATION][PARENTESIS_CERRAR] = 48;
  tas[NT_VARIABLE_DECLARATION][COMA] = 48;
  tas[NT_VARIABLE_DECLARATION][PUNTO_Y_COMA] = 48;
  tas[NT_VARIABLE_DECLARATION][OP_ASIGNACION] = 48;

  tas[NT_LISTA_VARIABLE_DECLARATOR][COMA] = 49;
  tas[NT_LISTA_VARIABLE_DECLARATOR][PUNTO_Y_COMA] = 50;
  
  tas[NT_VARIABLE_DECLARATOR][CORCHETES_ABRIR] = 51;
  tas[NT_VARIABLE_DECLARATOR][IDENTIFICADOR] = 51;
  tas[NT_VARIABLE_DECLARATOR][PARENTESIS_CERRAR] = 51;
  tas[NT_VARIABLE_DECLARATOR][COMA] = 51;
  tas[NT_VARIABLE_DECLARATOR][PUNTO_Y_COMA] = 51;
  tas[NT_VARIABLE_DECLARATOR][OP_ASIGNACION] = 51;

  tas[NT_OPCIONAL_VARIABLE_INITIALIZER][OP_ASIGNACION] = 52;
  tas[NT_OPCIONAL_VARIABLE_INITIALIZER][COMA] = 53;
  tas[NT_OPCIONAL_VARIABLE_INITIALIZER][PUNTO_Y_COMA] = 53;

  tas[NT_VARIABLE_INITIALIZER][TRUE] = 54;
  tas[NT_VARIABLE_INITIALIZER][FALSE] = 54;
  tas[NT_VARIABLE_INITIALIZER][OCTAL] = 54;
  tas[NT_VARIABLE_INITIALIZER][DECIMAL] = 54;
  tas[NT_VARIABLE_INITIALIZER][HEXADECIMAL] = 54;
  tas[NT_VARIABLE_INITIALIZER][CADENA_CARACTERES] = 54;
  tas[NT_VARIABLE_INITIALIZER][IDENTIFICADOR] = 54;
  tas[NT_VARIABLE_INITIALIZER][PARENTESIS_ABRIR] = 54;

  tas[NT_EXPRESION][TRUE] = 55;
  tas[NT_EXPRESION][FALSE] = 55;
  tas[NT_EXPRESION][OCTAL] = 55;
  tas[NT_EXPRESION][DECIMAL] = 55;
  tas[NT_EXPRESION][HEXADECIMAL] = 55;
  tas[NT_EXPRESION][CADENA_CARACTERES] = 55;
  tas[NT_EXPRESION][IDENTIFICADOR] = 55;
  tas[NT_EXPRESION][PARENTESIS_ABRIR] = 55;

  tas[NT_EXPRESION_PRIMA][OP_INCREMENTO] = 56;
  tas[NT_EXPRESION_PRIMA][OP_DECREMENTO] = 56;
  tas[NT_EXPRESION_PRIMA][OP_MAS] = 57;
  tas[NT_EXPRESION_PRIMA][OP_MENOS] = 57;
  tas[NT_EXPRESION_PRIMA][OP_POR] = 57;
  tas[NT_EXPRESION_PRIMA][OP_DIVIDIR] = 57;
  tas[NT_EXPRESION_PRIMA][OP_MODULO] = 57;
  tas[NT_EXPRESION_PRIMA][OP_IGUAL_IGUAL] = 58;
  tas[NT_EXPRESION_PRIMA][OP_DISTINTO] = 58;
  tas[NT_EXPRESION_PRIMA][OP_MENOR] = 58;
  tas[NT_EXPRESION_PRIMA][OP_MAYOR] = 58;
  tas[NT_EXPRESION_PRIMA][OP_MENOR_IGUAL] = 58;
  tas[NT_EXPRESION_PRIMA][OP_MAYOR_IGUAL] = 58;
  tas[NT_EXPRESION_PRIMA][OP_AND] = 59;
  tas[NT_EXPRESION_PRIMA][OP_OR] = 59;
  tas[NT_EXPRESION_PRIMA][OP_MIEMBRO] = 60;
  tas[NT_EXPRESION_PRIMA][PUNTO_Y_COMA] = 61;
  tas[NT_EXPRESION_PRIMA][PARENTESIS_CERRAR] = 61;
  tas[NT_EXPRESION_PRIMA][CORCHETES_CERRAR] = 61;
  tas[NT_EXPRESION_PRIMA][COMA] = 61;

  tas[NT_EXPRESION_1][TRUE] = 62;
  tas[NT_EXPRESION_1][FALSE] = 62;
  tas[NT_EXPRESION_1][OCTAL] = 62;
  tas[NT_EXPRESION_1][DECIMAL] = 62;
  tas[NT_EXPRESION_1][HEXADECIMAL] = 62;
  tas[NT_EXPRESION_1][CADENA_CARACTERES] = 62;
  tas[NT_EXPRESION_1][IDENTIFICADOR] = 62;
  tas[NT_EXPRESION_1][PARENTESIS_ABRIR] = 62;

  tas[NT_EXPRESION_1_PRIMA][PARENTESIS_ABRIR] = 63;
  tas[NT_EXPRESION_1_PRIMA][CORCHETES_ABRIR] = 63;
  tas[NT_EXPRESION_1_PRIMA][OP_AND] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_OR] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_IGUAL_IGUAL] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_DISTINTO] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MENOR] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MAYOR] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MENOR_IGUAL] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MAYOR_IGUAL] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_INCREMENTO] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_DECREMENTO] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MAS] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MENOS] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_POR] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_DIVIDIR] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MODULO] = 64;
  tas[NT_EXPRESION_1_PRIMA][OP_MIEMBRO] = 64;
  tas[NT_EXPRESION_1_PRIMA][PUNTO_Y_COMA] = 64;
  tas[NT_EXPRESION_1_PRIMA][PARENTESIS_CERRAR] = 64;
  tas[NT_EXPRESION_1_PRIMA][CORCHETES_CERRAR] = 64;
  tas[NT_EXPRESION_1_PRIMA][COMA] = 64;

  tas[NT_EXPRESION_2][TRUE] = 65;
  tas[NT_EXPRESION_2][FALSE] = 65;
  tas[NT_EXPRESION_2][OCTAL] = 66;
  tas[NT_EXPRESION_2][DECIMAL] = 66;
  tas[NT_EXPRESION_2][HEXADECIMAL] = 66;
  tas[NT_EXPRESION_2][CADENA_CARACTERES] = 66;
  tas[NT_EXPRESION_2][IDENTIFICADOR] = 67;
  tas[NT_EXPRESION_2][PARENTESIS_ABRIR] = 68;

  tas[NT_EXPRESION_3][PARENTESIS_ABRIR] = 69;
  tas[NT_EXPRESION_3][CORCHETES_ABRIR] = 69;

  tas[NT_OP_INDECREMENTO][OP_INCREMENTO] = 70;
  tas[NT_OP_INDECREMENTO][OP_DECREMENTO] = 71;

  tas[NT_OP_ARITMETICO][OP_MAS] = 72;
  tas[NT_OP_ARITMETICO][OP_MENOS] = 73;
  tas[NT_OP_ARITMETICO][OP_POR] = 74;
  tas[NT_OP_ARITMETICO][OP_DIVIDIR] = 75;
  tas[NT_OP_ARITMETICO][OP_MODULO] = 76;

  tas[NT_OP_RELACIONAL][OP_MAYOR] = 77;
  tas[NT_OP_RELACIONAL][OP_MENOR] = 78;
  tas[NT_OP_RELACIONAL][OP_MAYOR_IGUAL] = 79;
  tas[NT_OP_RELACIONAL][OP_MENOR_IGUAL] = 80;
  tas[NT_OP_RELACIONAL][OP_IGUAL_IGUAL] = 81;
  tas[NT_OP_RELACIONAL][OP_DISTINTO] = 82;
  
  tas[NT_OP_LOGICO][OP_OR] = 83;
  tas[NT_OP_LOGICO][OP_AND] = 84;

  tas[NT_AGRUPA_EXPRESION][PARENTESIS_ABRIR] = 85;
  tas[NT_AGRUPA_EXPRESION][CORCHETES_ABRIR] = 86;

  tas[NT_OPCIONAL_ARGLIST][TRUE] = 87;
  tas[NT_OPCIONAL_ARGLIST][FALSE] = 87;
  tas[NT_OPCIONAL_ARGLIST][OCTAL] = 87;
  tas[NT_OPCIONAL_ARGLIST][DECIMAL] = 87;
  tas[NT_OPCIONAL_ARGLIST][HEXADECIMAL] = 87;
  tas[NT_OPCIONAL_ARGLIST][CADENA_CARACTERES] = 87;
  tas[NT_OPCIONAL_ARGLIST][IDENTIFICADOR] = 87;
  tas[NT_OPCIONAL_ARGLIST][PARENTESIS_ABRIR] = 87;
  tas[NT_OPCIONAL_ARGLIST][PARENTESIS_CERRAR] = 88;

  tas[NT_LITERAL_EXPRESION][OCTAL] = 89;
  tas[NT_LITERAL_EXPRESION][DECIMAL] = 89;
  tas[NT_LITERAL_EXPRESION][HEXADECIMAL] = 89;
  tas[NT_LITERAL_EXPRESION][CADENA_CARACTERES] = 90;

  tas[NT_INTEGER_LITERAL][OCTAL] = 91;
  tas[NT_INTEGER_LITERAL][DECIMAL] = 92;
  tas[NT_INTEGER_LITERAL][HEXADECIMAL] = 93;

  tas[NT_STRING][CADENA_CARACTERES] = 94;

  tas[NT_ARGLIST][TRUE] = 95;
  tas[NT_ARGLIST][FALSE] = 95;
  tas[NT_ARGLIST][OCTAL] = 95;
  tas[NT_ARGLIST][DECIMAL] = 95;
  tas[NT_ARGLIST][HEXADECIMAL] = 95;
  tas[NT_ARGLIST][CADENA_CARACTERES] = 95;
  tas[NT_ARGLIST][IDENTIFICADOR] = 95;
  tas[NT_ARGLIST][PARENTESIS_ABRIR] = 95;
  
  tas[NT_LISTA_EXPRESION][COMA] = 96;
  tas[NT_LISTA_EXPRESION][PARENTESIS_CERRAR] = 97;

  tas[NT_DO_STATMENT][DO] = 98;

  tas[NT_CONSTRUCTOR_DECLARATION][PARENTESIS_ABRIR] = 99;
  
  tas[NT_CONSTANTE_LOGICA][TRUE] = 100;
  tas[NT_CONSTANTE_LOGICA][FALSE] = 101;

  tas[NT_OPCIONAL_IDENTIFIER][OP_MIEMBRO] = 102;
  tas[NT_OPCIONAL_IDENTIFIER][OP_ASIGNACION] = 103;

  tas[NT_OP_ASIGNACION][OP_ASIGNACION] = 104;

  tas[NT_POSIBLE_STATMENT][OP_INCREMENTO] = 105;
  tas[NT_POSIBLE_STATMENT][OP_DECREMENTO] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MAS] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MENOS] = 105;
  tas[NT_POSIBLE_STATMENT][OP_POR] = 105;
  tas[NT_POSIBLE_STATMENT][OP_DIVIDIR] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MODULO] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MAYOR] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MENOR] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MAYOR_IGUAL] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MENOR_IGUAL] = 105;
  tas[NT_POSIBLE_STATMENT][OP_IGUAL_IGUAL] = 105;
  tas[NT_POSIBLE_STATMENT][OP_DISTINTO] = 105;
  tas[NT_POSIBLE_STATMENT][OP_AND] = 105;
  tas[NT_POSIBLE_STATMENT][OP_OR] = 105;
  tas[NT_POSIBLE_STATMENT][OP_MIEMBRO] = 105;
  tas[NT_POSIBLE_STATMENT][PUNTO_Y_COMA] = 105;
  tas[NT_POSIBLE_STATMENT][PARENTESIS_CERRAR] = 105;
  tas[NT_POSIBLE_STATMENT][CORCHETES_CERRAR] = 105;
  tas[NT_POSIBLE_STATMENT][COMA] = 105;

  tas[NT_POSIBLE_STATMENT][PARENTESIS_ABRIR] = 106;
  tas[NT_POSIBLE_STATMENT][CORCHETES_ABRIR] = 106;

  tas[NT_POSIBLE_STATMENT][OP_ASIGNACION] = 107;

  tas[NT_POSIBLE_STATMENT][IDENTIFICADOR] = 108;

  tas[NT_POSIBLE_CONST][TD_ENTERO] = 110;

  tas[NT_POSIBLE_CONST][TD_BOOLEAN] = 111;

  tas[NT_VARIABLE_DECLARATOR][PARENTESIS_ABRIR] = 112;

}
