%{
// $Id: jcc-analex.lex,v 1.9 2001/09/24 04:26:37 jpl Exp $

#include <fstream>
#include <stdio.h>
#include <string>
#include "data.hpp"


%}

Digito        [0-9]
Octal         [0-7]
Hexadecimal   [0-9ABCDEFabcdef]
Id            [a-zA-Z$_][a-zA-Z0-9_]*


%option noyywrap
%option yylineno
%x COMENTARIO 

%%

"/*"  				{BEGIN(COMENTARIO);} 

<COMENTARIO>[^*]*		;
<COMENTARIO>"*"+[^/]		;
<COMENTARIO>"*"+"/" 		{BEGIN (INITIAL);}

"//".*  			{}


"0"{Octal}+                     {return OCTAL;}

{Digito}+                       {return DECIMAL;}

"0x"{Hexadecimal}+              {return HEXADECIMAL;}

"true"                          {return TRUE;}

"false"                         {return FALSE;}

\"[^\"]*\"                      {return CADENA_CARACTERES;}

"++"                            {return OP_INCREMENTO;}

"--"                            {return OP_DECREMENTO;}

"+"                             {return OP_MAS;}

"-"                             {return OP_MENOS;}

"*"                             {return OP_POR;}

"/"                             {return OP_DIVIDIR;}

"%"                             {return OP_MODULO;}

"=="                            {return OP_IGUAL_IGUAL;}

"!="                            {return OP_DISTINTO;}

"<"                             {return OP_MENOR;}

">"                             {return OP_MAYOR;}

"<="                            {return OP_MENOR_IGUAL;}

">="                            {return OP_MAYOR_IGUAL;}

"&&"                            {return OP_AND;}

"||"                            {return OP_OR;}

"="                             {return OP_ASIGNACION;}

"."                             {return OP_MIEMBRO;}

"int"                           {return TD_ENTERO;}

"boolean"                       {return TD_BOOLEAN;}

"void"                          {return TD_VOID;}

";"                             {return PUNTO_Y_COMA;}

","                             {return COMA;}

"("                             {return PARENTESIS_ABRIR;}

")"                             {return PARENTESIS_CERRAR;}

"{"                             {return LLAVES_ABRIR;}

"}"                             {return LLAVES_CERRAR;}

"["                             {return CORCHETES_ABRIR;}

"]"                             {return CORCHETES_CERRAR;}

"return"                        {return RETURN;}

"class"                         {return CLASS;}

"public"                        {return PUBLIC;}

"private"                       {return PRIVATE;}

"while"                         {return WHILE;}

"do"                            {return DO;}

"const"                         {return CONST;}
 
{Id}                            {return IDENTIFICADOR;}

[ \t\n]+                        {}

.                               {return NO_RECONOCIDO;}

%%
