// $Id: jcc.cpp,v 1.13 2001/09/23 13:59:52 jpl Exp $

#include <iostream.h>
#include <stdlib.h>
#include <time.h>
#include "COpciones.hpp"
#include "CCompilador.hpp"
#include "CExcepciones.hpp"

void Uso(const char* nombre_programa);

//
// MAIN
//
int
main(int argc, char* argv[])
{
  time_t* hora;
  time(hora);
  
  try {
    // Se recogen las opciones del compilador.
    COpciones* opciones = new COpciones(argc, argv);
    if (opciones->Verbose()) opciones->Mostrar();

    // Se compila.
    CCompilador* compilador = new CCompilador(*opciones);
    compilador->Compilar();

    if (opciones->Verbose())
      cout<<endl<<"Compilacin concluda. "<<ctime(hora);   

    free(compilador);
    free(opciones);

    return EXIT_SUCCESS;
  }
  catch ( Lexico_Error_Ex le ) {
    cerr<<le.what()<<endl<<ERROR_COMPILACION<<ctime(hora);
    return EXIT_FAILURE;
  }
  catch ( Sintactico_Error_Ex se ) {
    cerr<<se.what()<<endl<<ERROR_COMPILACION<<ctime(hora);
    return EXIT_FAILURE;
  }
  catch ( Semantico_Error_Ex se ) {
    cerr<<se.what()<<endl<<ERROR_COMPILACION<<ctime(hora);
    return EXIT_FAILURE;
  }
  catch ( Argumentos_Incorrectos_Ex ai ) {
    cerr<<ai.what()<<endl;
    Uso(argv[0]);
    return EXIT_FAILURE;
  }
  catch ( Solo_Ayuda_Ex ) {
    Uso(argv[0]);
    return EXIT_SUCCESS;
  }
  catch ( Hubo_Error_Ex he ) {
    cerr<<he.what()<<" "<<ctime(hora);
    return EXIT_FAILURE;
  }
  catch ( ... ) {
    cerr<<"Excepcin no esperada..."<<endl;
    return EXIT_FAILURE;
  }
}

//
// USO
//
void 
Uso(const char* nombre_programa)
{
  cout<<"Uso: "<<nombre_programa<<" [opciones] <fichero>"<<endl<<endl;
  cout<<"\t-v, --verbose"<<endl;
  cout<<"\t-d, --debug"<<endl;
  cout<<"\t-o, --output <fich>\t Fichero para el Cdigo Intermedio."<<endl;
  cout<<"\t-h, --help"<<endl<<endl;
  cout<<"Diego Chaparro <dchaparro@acm.org>, Jos Pelegrn <josepl@acm.org>."<<endl;
}
